<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LeaderElection.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">LeaderElection.java</span></div><h1>LeaderElection.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.nio.ByteBuffer;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Random;
import java.util.Map.Entry;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.quorum.Vote;
import org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType;
import org.apache.zookeeper.server.quorum.QuorumPeer.QuorumServer;
import org.apache.zookeeper.server.quorum.QuorumPeer.ServerState;

/**
 * @deprecated This class has been deprecated as of release 3.4.0. 
 */
@Deprecated
public class LeaderElection implements Election  {
<span class="fc" id="L49">    private static final Logger LOG = LoggerFactory.getLogger(LeaderElection.class);</span>
<span class="fc" id="L50">    protected static final Random epochGen = new Random();</span>

    protected QuorumPeer self;

<span class="fc" id="L54">    public LeaderElection(QuorumPeer self) {</span>
<span class="fc" id="L55">        this.self = self;</span>
<span class="fc" id="L56">    }</span>

<span class="fc" id="L58">    protected static class ElectionResult {</span>
        public Vote vote;

        public int count;

        public Vote winner;

        public int winningCount;

        public int numValidVotes;
    }

    protected ElectionResult countVotes(HashMap&lt;InetSocketAddress, Vote&gt; votes, HashSet&lt;Long&gt; heardFrom) {
<span class="fc" id="L71">        final ElectionResult result = new ElectionResult();</span>
        // Initialize with null vote
<span class="fc" id="L73">        result.vote = new Vote(Long.MIN_VALUE, Long.MIN_VALUE);</span>
<span class="fc" id="L74">        result.winner = new Vote(Long.MIN_VALUE, Long.MIN_VALUE);</span>

        // First, filter out votes from unheard-from machines. Then
        // make the views consistent. Sometimes peers will have
        // different zxids for a server depending on timing.
<span class="fc" id="L79">        final HashMap&lt;InetSocketAddress, Vote&gt; validVotes = new HashMap&lt;InetSocketAddress, Vote&gt;();</span>
<span class="fc" id="L80">        final Map&lt;Long, Long&gt; maxZxids = new HashMap&lt;Long,Long&gt;();</span>
<span class="fc bfc" id="L81" title="All 2 branches covered.">        for (Map.Entry&lt;InetSocketAddress, Vote&gt; e : votes.entrySet()) {</span>
            // Only include votes from machines that we heard from
<span class="fc" id="L83">            final Vote v = e.getValue();</span>
<span class="fc bfc" id="L84" title="All 2 branches covered.">            if (heardFrom.contains(v.getId())) {</span>
<span class="fc" id="L85">                validVotes.put(e.getKey(), v);</span>
<span class="fc" id="L86">                Long val = maxZxids.get(v.getId());</span>
<span class="fc bfc" id="L87" title="All 4 branches covered.">                if (val == null || val &lt; v.getZxid()) {</span>
<span class="fc" id="L88">                    maxZxids.put(v.getId(), v.getZxid());</span>
            }
                    }
<span class="fc" id="L91">                }</span>

        // Make all zxids for a given vote id equal to the largest zxid seen for
        // that id
<span class="fc bfc" id="L95" title="All 2 branches covered.">        for (Map.Entry&lt;InetSocketAddress, Vote&gt; e : validVotes.entrySet()) {</span>
<span class="fc" id="L96">            final Vote v = e.getValue();</span>
<span class="fc" id="L97">            Long zxid = maxZxids.get(v.getId());</span>
<span class="fc bfc" id="L98" title="All 2 branches covered.">            if (v.getZxid() &lt; zxid) {</span>
                // This is safe inside an iterator as per
                // http://download.oracle.com/javase/1.5.0/docs/api/java/util/Map.Entry.html
<span class="fc" id="L101">                e.setValue(new Vote(v.getId(), zxid, v.getElectionEpoch(), v.getPeerEpoch(), v.getState()));</span>
            }
<span class="fc" id="L103">        }</span>

<span class="fc" id="L105">        result.numValidVotes = validVotes.size();</span>

<span class="fc" id="L107">        final HashMap&lt;Vote, Integer&gt; countTable = new HashMap&lt;Vote, Integer&gt;();</span>
        // Now do the tally
<span class="fc bfc" id="L109" title="All 2 branches covered.">        for (Vote v : validVotes.values()) {</span>
<span class="fc" id="L110">            Integer count = countTable.get(v);</span>
<span class="fc bfc" id="L111" title="All 2 branches covered.">            if (count == null) {</span>
<span class="fc" id="L112">                count = 0;</span>
            }
<span class="fc" id="L114">            countTable.put(v, count + 1);</span>
<span class="fc bfc" id="L115" title="All 2 branches covered.">            if (v.getId() == result.vote.getId()) {</span>
<span class="fc" id="L116">                result.count++;</span>
<span class="fc bfc" id="L117" title="All 2 branches covered.">            } else if (v.getZxid() &gt; result.vote.getZxid()</span>
<span class="pc bpc" id="L118" title="1 of 4 branches missed.">                    || (v.getZxid() == result.vote.getZxid() &amp;&amp; v.getId() &gt; result.vote.getId())) {</span>
<span class="fc" id="L119">                result.vote = v;</span>
<span class="fc" id="L120">                result.count = 1;</span>
            }
<span class="fc" id="L122">        }</span>
<span class="fc" id="L123">        result.winningCount = 0;</span>
<span class="fc" id="L124">        LOG.info(&quot;Election tally: &quot;);</span>
<span class="fc bfc" id="L125" title="All 2 branches covered.">        for (Entry&lt;Vote, Integer&gt; entry : countTable.entrySet()) {</span>
<span class="fc bfc" id="L126" title="All 2 branches covered.">            if (entry.getValue() &gt; result.winningCount) {</span>
<span class="fc" id="L127">                result.winningCount = entry.getValue();</span>
<span class="fc" id="L128">                result.winner = entry.getKey();</span>
            }
<span class="fc" id="L130">            LOG.info(entry.getKey().getId() + &quot;\t-&gt; &quot; + entry.getValue());</span>
<span class="fc" id="L131">        }</span>
<span class="fc" id="L132">        return result;</span>
    }

    /**
     * There is nothing to shutdown in this implementation of
     * leader election, so we simply have an empty method.
     */
<span class="fc" id="L139">    public void shutdown(){}</span>
    
    /**
     * Invoked in QuorumPeer to find or elect a new leader.
     * 
     * @throws InterruptedException
     */
    public Vote lookForLeader() throws InterruptedException {
        try {
<span class="fc" id="L148">            self.jmxLeaderElectionBean = new LeaderElectionBean();</span>
<span class="fc" id="L149">            MBeanRegistry.getInstance().register(</span>
                    self.jmxLeaderElectionBean, self.jmxLocalPeerBean);
<span class="fc" id="L151">        } catch (Exception e) {</span>
<span class="fc" id="L152">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L153">            self.jmxLeaderElectionBean = null;</span>
<span class="fc" id="L154">        }</span>

        try {
<span class="fc" id="L157">            self.setCurrentVote(new Vote(self.getId(),</span>
<span class="fc" id="L158">                    self.getLastLoggedZxid()));</span>
            // We are going to look for a leader by casting a vote for ourself
<span class="fc" id="L160">            byte requestBytes[] = new byte[4];</span>
<span class="fc" id="L161">            ByteBuffer requestBuffer = ByteBuffer.wrap(requestBytes);</span>
<span class="fc" id="L162">            byte responseBytes[] = new byte[28];</span>
<span class="fc" id="L163">            ByteBuffer responseBuffer = ByteBuffer.wrap(responseBytes);</span>
            /* The current vote for the leader. Initially me! */
<span class="fc" id="L165">            DatagramSocket s = null;</span>
            try {
<span class="fc" id="L167">                s = new DatagramSocket();</span>
<span class="fc" id="L168">                s.setSoTimeout(200);</span>
<span class="nc" id="L169">            } catch (SocketException e1) {</span>
<span class="nc" id="L170">                LOG.error(&quot;Socket exception when creating socket for leader election&quot;, e1);</span>
<span class="nc" id="L171">                System.exit(4);</span>
<span class="fc" id="L172">            }</span>
<span class="fc" id="L173">            DatagramPacket requestPacket = new DatagramPacket(requestBytes,</span>
                    requestBytes.length);
<span class="fc" id="L175">            DatagramPacket responsePacket = new DatagramPacket(responseBytes,</span>
                    responseBytes.length);
<span class="fc" id="L177">            int xid = epochGen.nextInt();</span>
<span class="fc bfc" id="L178" title="All 2 branches covered.">            while (self.isRunning()) {</span>
<span class="fc" id="L179">                HashMap&lt;InetSocketAddress, Vote&gt; votes =</span>
<span class="fc" id="L180">                    new HashMap&lt;InetSocketAddress, Vote&gt;(self.getVotingView().size());</span>

<span class="fc" id="L182">                requestBuffer.clear();</span>
<span class="fc" id="L183">                requestBuffer.putInt(xid);</span>
<span class="fc" id="L184">                requestPacket.setLength(4);</span>
<span class="fc" id="L185">                HashSet&lt;Long&gt; heardFrom = new HashSet&lt;Long&gt;();</span>
<span class="fc bfc" id="L186" title="All 2 branches covered.">                for (QuorumServer server : self.getVotingView().values()) {</span>
<span class="fc" id="L187">                    LOG.info(&quot;Server address: &quot; + server.addr);</span>
                    try {
<span class="fc" id="L189">                        requestPacket.setSocketAddress(server.addr);</span>
<span class="nc" id="L190">                    } catch (IllegalArgumentException e) {</span>
                        // Sun doesn't include the address that causes this
                        // exception to be thrown, so we wrap the exception
                        // in order to capture this critical detail.
<span class="nc" id="L194">                        throw new IllegalArgumentException(</span>
                                &quot;Unable to set socket address on packet, msg:&quot;
<span class="nc" id="L196">                                + e.getMessage() + &quot; with addr:&quot; + server.addr,</span>
                                e);
<span class="fc" id="L198">                    }</span>

                    try {
<span class="fc" id="L201">                        s.send(requestPacket);</span>
<span class="fc" id="L202">                        responsePacket.setLength(responseBytes.length);</span>
<span class="fc" id="L203">                        s.receive(responsePacket);</span>
<span class="pc bpc" id="L204" title="1 of 2 branches missed.">                        if (responsePacket.getLength() != responseBytes.length) {</span>
<span class="nc" id="L205">                            LOG.error(&quot;Got a short response: &quot;</span>
<span class="nc" id="L206">                                    + responsePacket.getLength());</span>
<span class="nc" id="L207">                            continue;</span>
                        }
<span class="fc" id="L209">                        responseBuffer.clear();</span>
<span class="fc" id="L210">                        int recvedXid = responseBuffer.getInt();</span>
<span class="pc bpc" id="L211" title="1 of 2 branches missed.">                        if (recvedXid != xid) {</span>
<span class="nc" id="L212">                            LOG.error(&quot;Got bad xid: expected &quot; + xid</span>
                                    + &quot; got &quot; + recvedXid);
<span class="nc" id="L214">                            continue;</span>
                        }
<span class="fc" id="L216">                        long peerId = responseBuffer.getLong();</span>
<span class="fc" id="L217">                        heardFrom.add(peerId);</span>
                        //if(server.id != peerId){
<span class="fc" id="L219">                            Vote vote = new Vote(responseBuffer.getLong(),</span>
<span class="fc" id="L220">                                responseBuffer.getLong());</span>
<span class="fc" id="L221">                            InetSocketAddress addr =</span>
                                (InetSocketAddress) responsePacket
<span class="fc" id="L223">                                .getSocketAddress();</span>
<span class="fc" id="L224">                            votes.put(addr, vote);</span>
                        //}
<span class="fc" id="L226">                    } catch (IOException e) {</span>
<span class="fc" id="L227">                        LOG.warn(&quot;Ignoring exception while looking for leader&quot;,</span>
                                e);
                        // Errors are okay, since hosts may be
                        // down
<span class="fc" id="L231">                    }</span>
<span class="fc" id="L232">                }</span>

<span class="fc" id="L234">                ElectionResult result = countVotes(votes, heardFrom);</span>
                // ZOOKEEPER-569:
                // If no votes are received for live peers, reset to voting 
                // for ourselves as otherwise we may hang on to a vote 
                // for a dead peer                 
<span class="pc bpc" id="L239" title="1 of 2 branches missed.">                if (result.numValidVotes == 0) {</span>
<span class="nc" id="L240">                    self.setCurrentVote(new Vote(self.getId(),</span>
<span class="nc" id="L241">                            self.getLastLoggedZxid()));</span>
                } else {
<span class="pc bpc" id="L243" title="1 of 2 branches missed.">                    if (result.winner.getId() &gt;= 0) {</span>
<span class="fc" id="L244">                        self.setCurrentVote(result.vote);</span>
                        // To do: this doesn't use a quorum verifier
<span class="fc bfc" id="L246" title="All 2 branches covered.">                        if (result.winningCount &gt; (self.getVotingView().size() / 2)) {</span>
<span class="fc" id="L247">                            self.setCurrentVote(result.winner);</span>
<span class="fc" id="L248">                            s.close();</span>
<span class="fc" id="L249">                            Vote current = self.getCurrentVote();</span>
<span class="fc" id="L250">                            LOG.info(&quot;Found leader: my type is: &quot; + self.getLearnerType());</span>
                            /*
                             * We want to make sure we implement the state machine
                             * correctly. If we are a PARTICIPANT, once a leader
                             * is elected we can move either to LEADING or 
                             * FOLLOWING. However if we are an OBSERVER, it is an
                             * error to be elected as a Leader.
                             */
<span class="fc bfc" id="L258" title="All 2 branches covered.">                            if (self.getLearnerType() == LearnerType.OBSERVER) {</span>
<span class="pc bpc" id="L259" title="1 of 2 branches missed.">                                if (current.getId() == self.getId()) {</span>
                                    // This should never happen!
<span class="nc" id="L261">                                    LOG.error(&quot;OBSERVER elected as leader!&quot;);</span>
<span class="nc" id="L262">                                    Thread.sleep(100);</span>
                                }
                                else {
<span class="fc" id="L265">                                    self.setPeerState(ServerState.OBSERVING);</span>
<span class="fc" id="L266">                                    Thread.sleep(100);</span>
<span class="fc" id="L267">                                    return current;</span>
                                }
                            } else {
<span class="fc bfc" id="L270" title="All 2 branches covered.">                                self.setPeerState((current.getId() == self.getId())</span>
                                        ? ServerState.LEADING: ServerState.FOLLOWING);
<span class="fc bfc" id="L272" title="All 2 branches covered.">                                if (self.getPeerState() == ServerState.FOLLOWING) {</span>
<span class="fc" id="L273">                                    Thread.sleep(100);</span>
                                }                            
<span class="fc" id="L275">                                return current;</span>
                            }
                        }
                    }
                }
<span class="fc" id="L280">                Thread.sleep(1000);</span>
<span class="fc" id="L281">            }</span>
<span class="fc" id="L282">            return null;</span>
        } finally {
<span class="pc" id="L284">            try {</span>
<span class="pc bpc" id="L285" title="4 of 8 branches missed.">                if(self.jmxLeaderElectionBean != null){</span>
<span class="pc" id="L286">                    MBeanRegistry.getInstance().unregister(</span>
                            self.jmxLeaderElectionBean);
                }
<span class="nc" id="L289">            } catch (Exception e) {</span>
<span class="nc" id="L290">                LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="pc" id="L291">            }</span>
<span class="pc" id="L292">            self.jmxLeaderElectionBean = null;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>